var
      url = require('url'),
      getLogger = require('./lib/getLogger');

var
      logger, cfg;

module.exports = function(_cfg, _logger){
   cfg = _cfg || {};
   logger = getLogger(_logger);

   return function(request, response, next){
      var
         data = request.body,
         cookies = request.cookies,
         uid = request.headers['X-SPID'] || request.headers['x-spid'] || cookies.CpsUserId || cookies.cpsuserid,
         hosts = cfg.hosts,
         error,
         errorCode = 500;

      data.userAgent = request.headers['user-agent'];
      data.protocol = request.protocol || 'https';
      data.host = data._url = request.headers.host || request.headers.Host || url.parse(data._url).hostname || data._url;

      if (data.host.indexOf('xp-') !== -1) {
         data.host = data.host.replace('xp-', '');
      }

      if (hosts.allowed.indexOf(data.host) === -1) {
         error = 'Request made from not allowed host';
      }
      if (!uid){
         error = 'Cookie CpsUserId is missing';
         errorCode = 401;
      }
      if (!cookies.sid){
         error = 'Cookie sid is missing';
         errorCode = 401;
      }
      if (error) {
         logger.warn('authorization', error + '\n' +
            'headers: ' + JSON.stringify(request.headers));
         return response.status(errorCode).json({
            error: error
         });
      }

      data.cpsUserId = data.uid = uid;
      data.sid = cookies.sid;
      data.userId = parseInt(data.sid.split('-')[1], 16);

      if(cookies.useragent && cookies.useragent == 'notifier'){
         data.notifier = true;
      }

      next();
   }
};