var
   pg = require('pg'),
   logger = require('./../logger/logger'),
   db = require('../../../config').get('db'),
   conString = ['postgres://', db.username, ':', db.password, '@', db.address, '/', db.dbname].join('');

var getClient = function () {
   var TIMER = 1000;
   return new Promise(function (resolve) {
      var connect = function () {
         var client = new pg.Client(conString);

         client.on('end', function () {
            client.removeAllListeners();
         });
         client.on('error', function (err) {
            logger.warn('pgClient', err.message || err);
         });

         client.connect(function (err) {
            if (!err) {
               resolve(client);
            } else {
               logger.warn('pgClient', 'Ошибка подключения к базе данных ' + err.message || err);
               setTimeout(function () {
                  TIMER *= 2;
                  connect();
               }, TIMER);
            }
         })
      };
      connect();
   });
};

module.exports = {
   getClient: getClient
}