var
   pg = require('pg'),
   logger = require('./../logger/logger'),
   DBStreamer = require('./DBStreamer'),
   pgClient = require('./pgClient'),
   types = pg.types;

var
   streamers = {},
   clientPromise = null;


types.setTypeParser(1114, function (stringValue) {
   return stringValue;
});

types.setTypeParser(20, function(stringValue) {
   var val;
   try {
      val = parseInt(stringValue, 10);
   } catch(e) {
      val = stringValue;
   }
   return val;
});



module.exports = function () {
   return {
      query: function (query, data, queryName) {
         if (!clientPromise) {
            clientPromise = pgClient.getClient();
            clientPromise.then((pgClient) => {
               pgClient.on('error', function (err) {
                  pgClient.end();
                  clientPromise = null;
               });
            })
         }
         return clientPromise.then((pgClient) => {
            pgClient.query("SET application_name = '" + queryName + "';");
            return new Promise((resolve, reject) => {
               pgClient.query(query, data, function (err, result) {
                  if (err) {
                     reject(err);
                  } else {
                     resolve(result)
                  }
               });
            })

         })
      },
      copy: function (query, data, queryName) {
         if (!streamers[queryName]) {
            streamers[queryName] = new DBStreamer(query, queryName);
         }
         streamers[queryName].copy(data);
         return Promise.resolve();
      },
      end: function () {
         pg.end();
      }
   };
};
